#! /usr/bin/env node
// 文件模块
import fs from 'fs'

// 运行命令的模块
import child_process from 'child_process'

// 第三方删除目录模块
import rimraf from 'rimraf'

// 项目配置
import * as conf from './config.js'

// 获取模板
import * as template from './createTemplate.js'

// 删除原有的目录
rimraf(`${getRootPath()}`, err => {
  if (err) return err
})
// 创建项目的根目录
fs.mkdirSync(`${getRootPath()}`)

// 获取cmd输入的内容
let config = conf.conf
// 创建项目的入口文件
fs.writeFileSync(`${getRootPath()}/app.js`, template.appTemplate(config.middleware, config.Port))
// 创建项目的package.json文件
fs.writeFileSync(`${getRootPath()}/package.json`, template.packageTemplate(config.middleware, config.Name))

// 安装依赖
child_process.exec(`cd ${getRootPath()} && npm install`, (err, result, errResult) => {
  if (!err) {
    console.log(`项目创建完成:\n${result}`)
  } else {
    console.log(`项目创建完成:\n${errResult}`)
  }
})

// 获取根路径
function getRootPath() {
  let path = conf.conf.Name
  return `./${path}`
}
